package cn.iocoder.yudao.module.member.service.billing;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.member.controller.admin.billing.vo.BillingPageDataVo;
import cn.iocoder.yudao.module.member.controller.admin.billing.vo.BillingPageReqVO;
import cn.iocoder.yudao.module.member.controller.admin.billing.vo.BillingRespMoneyVO;
import cn.iocoder.yudao.module.member.controller.admin.billing.vo.BillingSaveReqVO;
import cn.iocoder.yudao.module.member.dal.dataobject.billing.BillingDO;
import javax.validation.*;
import java.math.BigDecimal;
import java.util.Date;
import java.util.Map;

/**
 * 开票记录 Service 接口
 *
 * @author 管理员
 */
public interface BillingService {

    /**
     * 创建开票记录
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    String createBilling(@Valid BillingSaveReqVO createReqVO);

    /**
     * 单位统一开票
     * @param createReqVO
     * @return
     */
    String createBillingUnit(@Valid BillingSaveReqVO createReqVO);

    /**
     * 更新开票记录
     *
     * @param updateReqVO 更新信息
     */
    void updateBilling(@Valid BillingSaveReqVO updateReqVO);
    void updateBillingUnit(@Valid BillingSaveReqVO updateReqVO);

    /**
     * 删除开票记录
     *
     * @param id 编号
     */
    void deleteBilling(String id);

    /**
     * 获得开票记录
     *
     * @param id 编号
     * @return 开票记录
     */
    BillingDO getBilling(String id);

    /**
     * 获得开票记录分页
     *
     * @param pageReqVO 分页查询
     * @return 开票记录分页
     */
    PageResult<BillingDO> getBillingPage(BillingPageReqVO pageReqVO);
    BillingRespMoneyVO getHaveWithoutMoney(Long userId,Long carteenId);
    BillingRespMoneyVO getUserHaveWithoutMoney(Long userId,Long carteenId);
    BillingRespMoneyVO getHaveWithoutMoney(Long userId);

    /**
     * 获取指定时间段的所有金额
     * @return
     */
    BigDecimal getTotalMoney(BillingPageDataVo vo);
    BigDecimal getUserTotalMoney(BillingPageDataVo vo);
    Object getData(BillingPageDataVo vo);
    String getMemberId(Long userId);

    /**
     * 开票完成数量，开票中数量，开票回拒数量
     * @param carteenId
     * @param userId
     * @return
     */
    Map<Integer, Integer>getBillingTypeTotal(Long carteenId, Long userId);
}